import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import React, { Component } from 'react'; // This HoC creates the PageComponent prepared for the Client Side Rendering
// It renders a placeholder, if any specified as `renderLoading` on the PageComponent
// Also, executes the getInitialProps to retrieve the initialProps and then
// Renders the component with the initialProps, hiding the placeholder

export default (function (_ref) {
  var context = _ref.context,
      routeInfo = _ref.routeInfo;
  return function (Page) {
    var _class, _temp;

    return _temp = _class =
    /*#__PURE__*/
    function (_Component) {
      _inheritsLoose(ClientPage, _Component);

      function ClientPage() {
        var _this;

        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        _this = _Component.call.apply(_Component, [this].concat(args)) || this;
        _this.state = {
          initialProps: {},
          isLoading: true
        };
        return _this;
      }

      var _proto = ClientPage.prototype;

      _proto._renderLoading = function _renderLoading() {
        // check if the page has a renderLoading method, if not, just render nothing
        return Page.renderLoading ? Page.renderLoading() : null;
      };

      _proto.componentDidMount = function componentDidMount() {
        var _this2 = this;

        // get the initialProps by executing the provided method on the page
        // when got the results, update the state to re-render the page hiding the placeholder
        Page.getInitialProps({
          context: context,
          routeInfo: routeInfo
        }).then(function (initialProps) {
          _this2.setState({
            initialProps: initialProps,
            isLoading: false
          });
        }).catch(function (err) {
          // pass error as prop
          _this2.setState({
            initialProps: {
              error: err
            },
            isLoading: false
          });
        });
      };

      _proto.render = function render() {
        return this.state.isLoading ? this._renderLoading() : React.createElement(Page, Object.assign({}, this.state.initialProps, this.props));
      };

      return ClientPage;
    }(Component), _class.displayName = "ClientPage(" + Page.displayName + ")", _temp;
  };
});